// Code generated by go-swagger; DO NOT EDIT.

package secret_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewDeleteRandomIntegrationParams creates a new DeleteRandomIntegrationParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewDeleteRandomIntegrationParams() *DeleteRandomIntegrationParams {
	return &DeleteRandomIntegrationParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewDeleteRandomIntegrationParamsWithTimeout creates a new DeleteRandomIntegrationParams object
// with the ability to set a timeout on a request.
func NewDeleteRandomIntegrationParamsWithTimeout(timeout time.Duration) *DeleteRandomIntegrationParams {
	return &DeleteRandomIntegrationParams{
		timeout: timeout,
	}
}

// NewDeleteRandomIntegrationParamsWithContext creates a new DeleteRandomIntegrationParams object
// with the ability to set a context for a request.
func NewDeleteRandomIntegrationParamsWithContext(ctx context.Context) *DeleteRandomIntegrationParams {
	return &DeleteRandomIntegrationParams{
		Context: ctx,
	}
}

// NewDeleteRandomIntegrationParamsWithHTTPClient creates a new DeleteRandomIntegrationParams object
// with the ability to set a custom HTTPClient for a request.
func NewDeleteRandomIntegrationParamsWithHTTPClient(client *http.Client) *DeleteRandomIntegrationParams {
	return &DeleteRandomIntegrationParams{
		HTTPClient: client,
	}
}

/*
DeleteRandomIntegrationParams contains all the parameters to send to the API endpoint

	for the delete random integration operation.

	Typically these are written to a http.Request.
*/
type DeleteRandomIntegrationParams struct {

	// Name.
	Name string

	// OrganizationID.
	OrganizationID string

	// ProjectID.
	ProjectID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the delete random integration params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteRandomIntegrationParams) WithDefaults() *DeleteRandomIntegrationParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the delete random integration params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteRandomIntegrationParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the delete random integration params
func (o *DeleteRandomIntegrationParams) WithTimeout(timeout time.Duration) *DeleteRandomIntegrationParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the delete random integration params
func (o *DeleteRandomIntegrationParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the delete random integration params
func (o *DeleteRandomIntegrationParams) WithContext(ctx context.Context) *DeleteRandomIntegrationParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the delete random integration params
func (o *DeleteRandomIntegrationParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the delete random integration params
func (o *DeleteRandomIntegrationParams) WithHTTPClient(client *http.Client) *DeleteRandomIntegrationParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the delete random integration params
func (o *DeleteRandomIntegrationParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithName adds the name to the delete random integration params
func (o *DeleteRandomIntegrationParams) WithName(name string) *DeleteRandomIntegrationParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the delete random integration params
func (o *DeleteRandomIntegrationParams) SetName(name string) {
	o.Name = name
}

// WithOrganizationID adds the organizationID to the delete random integration params
func (o *DeleteRandomIntegrationParams) WithOrganizationID(organizationID string) *DeleteRandomIntegrationParams {
	o.SetOrganizationID(organizationID)
	return o
}

// SetOrganizationID adds the organizationId to the delete random integration params
func (o *DeleteRandomIntegrationParams) SetOrganizationID(organizationID string) {
	o.OrganizationID = organizationID
}

// WithProjectID adds the projectID to the delete random integration params
func (o *DeleteRandomIntegrationParams) WithProjectID(projectID string) *DeleteRandomIntegrationParams {
	o.SetProjectID(projectID)
	return o
}

// SetProjectID adds the projectId to the delete random integration params
func (o *DeleteRandomIntegrationParams) SetProjectID(projectID string) {
	o.ProjectID = projectID
}

// WriteToRequest writes these params to a swagger request
func (o *DeleteRandomIntegrationParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param name
	if err := r.SetPathParam("name", o.Name); err != nil {
		return err
	}

	// path param organization_id
	if err := r.SetPathParam("organization_id", o.OrganizationID); err != nil {
		return err
	}

	// path param project_id
	if err := r.SetPathParam("project_id", o.ProjectID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
