// Code generated by go-swagger; DO NOT EDIT.

package secret_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewDescribeProviderParams creates a new DescribeProviderParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewDescribeProviderParams() *DescribeProviderParams {
	return &DescribeProviderParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewDescribeProviderParamsWithTimeout creates a new DescribeProviderParams object
// with the ability to set a timeout on a request.
func NewDescribeProviderParamsWithTimeout(timeout time.Duration) *DescribeProviderParams {
	return &DescribeProviderParams{
		timeout: timeout,
	}
}

// NewDescribeProviderParamsWithContext creates a new DescribeProviderParams object
// with the ability to set a context for a request.
func NewDescribeProviderParamsWithContext(ctx context.Context) *DescribeProviderParams {
	return &DescribeProviderParams{
		Context: ctx,
	}
}

// NewDescribeProviderParamsWithHTTPClient creates a new DescribeProviderParams object
// with the ability to set a custom HTTPClient for a request.
func NewDescribeProviderParamsWithHTTPClient(client *http.Client) *DescribeProviderParams {
	return &DescribeProviderParams{
		HTTPClient: client,
	}
}

/*
DescribeProviderParams contains all the parameters to send to the API endpoint

	for the describe provider operation.

	Typically these are written to a http.Request.
*/
type DescribeProviderParams struct {

	// Name.
	Name string

	// OrganizationID.
	OrganizationID string

	// ProjectID.
	ProjectID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the describe provider params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DescribeProviderParams) WithDefaults() *DescribeProviderParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the describe provider params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DescribeProviderParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the describe provider params
func (o *DescribeProviderParams) WithTimeout(timeout time.Duration) *DescribeProviderParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the describe provider params
func (o *DescribeProviderParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the describe provider params
func (o *DescribeProviderParams) WithContext(ctx context.Context) *DescribeProviderParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the describe provider params
func (o *DescribeProviderParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the describe provider params
func (o *DescribeProviderParams) WithHTTPClient(client *http.Client) *DescribeProviderParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the describe provider params
func (o *DescribeProviderParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithName adds the name to the describe provider params
func (o *DescribeProviderParams) WithName(name string) *DescribeProviderParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the describe provider params
func (o *DescribeProviderParams) SetName(name string) {
	o.Name = name
}

// WithOrganizationID adds the organizationID to the describe provider params
func (o *DescribeProviderParams) WithOrganizationID(organizationID string) *DescribeProviderParams {
	o.SetOrganizationID(organizationID)
	return o
}

// SetOrganizationID adds the organizationId to the describe provider params
func (o *DescribeProviderParams) SetOrganizationID(organizationID string) {
	o.OrganizationID = organizationID
}

// WithProjectID adds the projectID to the describe provider params
func (o *DescribeProviderParams) WithProjectID(projectID string) *DescribeProviderParams {
	o.SetProjectID(projectID)
	return o
}

// SetProjectID adds the projectId to the describe provider params
func (o *DescribeProviderParams) SetProjectID(projectID string) {
	o.ProjectID = projectID
}

// WriteToRequest writes these params to a swagger request
func (o *DescribeProviderParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param name
	if err := r.SetPathParam("name", o.Name); err != nil {
		return err
	}

	// path param organization_id
	if err := r.SetPathParam("organization_id", o.OrganizationID); err != nil {
		return err
	}

	// path param project_id
	if err := r.SetPathParam("project_id", o.ProjectID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
