// Code generated by go-swagger; DO NOT EDIT.

package secret_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewGetRandomIntegrationParams creates a new GetRandomIntegrationParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetRandomIntegrationParams() *GetRandomIntegrationParams {
	return &GetRandomIntegrationParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetRandomIntegrationParamsWithTimeout creates a new GetRandomIntegrationParams object
// with the ability to set a timeout on a request.
func NewGetRandomIntegrationParamsWithTimeout(timeout time.Duration) *GetRandomIntegrationParams {
	return &GetRandomIntegrationParams{
		timeout: timeout,
	}
}

// NewGetRandomIntegrationParamsWithContext creates a new GetRandomIntegrationParams object
// with the ability to set a context for a request.
func NewGetRandomIntegrationParamsWithContext(ctx context.Context) *GetRandomIntegrationParams {
	return &GetRandomIntegrationParams{
		Context: ctx,
	}
}

// NewGetRandomIntegrationParamsWithHTTPClient creates a new GetRandomIntegrationParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetRandomIntegrationParamsWithHTTPClient(client *http.Client) *GetRandomIntegrationParams {
	return &GetRandomIntegrationParams{
		HTTPClient: client,
	}
}

/*
GetRandomIntegrationParams contains all the parameters to send to the API endpoint

	for the get random integration operation.

	Typically these are written to a http.Request.
*/
type GetRandomIntegrationParams struct {

	// Name.
	Name string

	// OrganizationID.
	OrganizationID string

	// ProjectID.
	ProjectID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get random integration params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetRandomIntegrationParams) WithDefaults() *GetRandomIntegrationParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get random integration params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetRandomIntegrationParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get random integration params
func (o *GetRandomIntegrationParams) WithTimeout(timeout time.Duration) *GetRandomIntegrationParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get random integration params
func (o *GetRandomIntegrationParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get random integration params
func (o *GetRandomIntegrationParams) WithContext(ctx context.Context) *GetRandomIntegrationParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get random integration params
func (o *GetRandomIntegrationParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get random integration params
func (o *GetRandomIntegrationParams) WithHTTPClient(client *http.Client) *GetRandomIntegrationParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get random integration params
func (o *GetRandomIntegrationParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithName adds the name to the get random integration params
func (o *GetRandomIntegrationParams) WithName(name string) *GetRandomIntegrationParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the get random integration params
func (o *GetRandomIntegrationParams) SetName(name string) {
	o.Name = name
}

// WithOrganizationID adds the organizationID to the get random integration params
func (o *GetRandomIntegrationParams) WithOrganizationID(organizationID string) *GetRandomIntegrationParams {
	o.SetOrganizationID(organizationID)
	return o
}

// SetOrganizationID adds the organizationId to the get random integration params
func (o *GetRandomIntegrationParams) SetOrganizationID(organizationID string) {
	o.OrganizationID = organizationID
}

// WithProjectID adds the projectID to the get random integration params
func (o *GetRandomIntegrationParams) WithProjectID(projectID string) *GetRandomIntegrationParams {
	o.SetProjectID(projectID)
	return o
}

// SetProjectID adds the projectId to the get random integration params
func (o *GetRandomIntegrationParams) SetProjectID(projectID string) {
	o.ProjectID = projectID
}

// WriteToRequest writes these params to a swagger request
func (o *GetRandomIntegrationParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param name
	if err := r.SetPathParam("name", o.Name); err != nil {
		return err
	}

	// path param organization_id
	if err := r.SetPathParam("organization_id", o.OrganizationID); err != nil {
		return err
	}

	// path param project_id
	if err := r.SetPathParam("project_id", o.ProjectID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
