// Code generated by go-swagger; DO NOT EDIT.

package secret_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewPurgeAppAndSecretsParams creates a new PurgeAppAndSecretsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPurgeAppAndSecretsParams() *PurgeAppAndSecretsParams {
	return &PurgeAppAndSecretsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPurgeAppAndSecretsParamsWithTimeout creates a new PurgeAppAndSecretsParams object
// with the ability to set a timeout on a request.
func NewPurgeAppAndSecretsParamsWithTimeout(timeout time.Duration) *PurgeAppAndSecretsParams {
	return &PurgeAppAndSecretsParams{
		timeout: timeout,
	}
}

// NewPurgeAppAndSecretsParamsWithContext creates a new PurgeAppAndSecretsParams object
// with the ability to set a context for a request.
func NewPurgeAppAndSecretsParamsWithContext(ctx context.Context) *PurgeAppAndSecretsParams {
	return &PurgeAppAndSecretsParams{
		Context: ctx,
	}
}

// NewPurgeAppAndSecretsParamsWithHTTPClient creates a new PurgeAppAndSecretsParams object
// with the ability to set a custom HTTPClient for a request.
func NewPurgeAppAndSecretsParamsWithHTTPClient(client *http.Client) *PurgeAppAndSecretsParams {
	return &PurgeAppAndSecretsParams{
		HTTPClient: client,
	}
}

/*
PurgeAppAndSecretsParams contains all the parameters to send to the API endpoint

	for the purge app and secrets operation.

	Typically these are written to a http.Request.
*/
type PurgeAppAndSecretsParams struct {

	// Name.
	Name string

	// OrganizationID.
	OrganizationID string

	// ProjectID.
	ProjectID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the purge app and secrets params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PurgeAppAndSecretsParams) WithDefaults() *PurgeAppAndSecretsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the purge app and secrets params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PurgeAppAndSecretsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the purge app and secrets params
func (o *PurgeAppAndSecretsParams) WithTimeout(timeout time.Duration) *PurgeAppAndSecretsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the purge app and secrets params
func (o *PurgeAppAndSecretsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the purge app and secrets params
func (o *PurgeAppAndSecretsParams) WithContext(ctx context.Context) *PurgeAppAndSecretsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the purge app and secrets params
func (o *PurgeAppAndSecretsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the purge app and secrets params
func (o *PurgeAppAndSecretsParams) WithHTTPClient(client *http.Client) *PurgeAppAndSecretsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the purge app and secrets params
func (o *PurgeAppAndSecretsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithName adds the name to the purge app and secrets params
func (o *PurgeAppAndSecretsParams) WithName(name string) *PurgeAppAndSecretsParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the purge app and secrets params
func (o *PurgeAppAndSecretsParams) SetName(name string) {
	o.Name = name
}

// WithOrganizationID adds the organizationID to the purge app and secrets params
func (o *PurgeAppAndSecretsParams) WithOrganizationID(organizationID string) *PurgeAppAndSecretsParams {
	o.SetOrganizationID(organizationID)
	return o
}

// SetOrganizationID adds the organizationId to the purge app and secrets params
func (o *PurgeAppAndSecretsParams) SetOrganizationID(organizationID string) {
	o.OrganizationID = organizationID
}

// WithProjectID adds the projectID to the purge app and secrets params
func (o *PurgeAppAndSecretsParams) WithProjectID(projectID string) *PurgeAppAndSecretsParams {
	o.SetProjectID(projectID)
	return o
}

// SetProjectID adds the projectId to the purge app and secrets params
func (o *PurgeAppAndSecretsParams) SetProjectID(projectID string) {
	o.ProjectID = projectID
}

// WriteToRequest writes these params to a swagger request
func (o *PurgeAppAndSecretsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param name
	if err := r.SetPathParam("name", o.Name); err != nil {
		return err
	}

	// path param organization_id
	if err := r.SetPathParam("organization_id", o.OrganizationID); err != nil {
		return err
	}

	// path param project_id
	if err := r.SetPathParam("project_id", o.ProjectID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
