// Code generated by go-swagger; DO NOT EDIT.

package waypoint_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/hashicorp/hcp-sdk-go/clients/cloud-waypoint-service/preview/2024-11-22/models"
)

// NewWaypointServiceCreateVariableParams creates a new WaypointServiceCreateVariableParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewWaypointServiceCreateVariableParams() *WaypointServiceCreateVariableParams {
	return &WaypointServiceCreateVariableParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewWaypointServiceCreateVariableParamsWithTimeout creates a new WaypointServiceCreateVariableParams object
// with the ability to set a timeout on a request.
func NewWaypointServiceCreateVariableParamsWithTimeout(timeout time.Duration) *WaypointServiceCreateVariableParams {
	return &WaypointServiceCreateVariableParams{
		timeout: timeout,
	}
}

// NewWaypointServiceCreateVariableParamsWithContext creates a new WaypointServiceCreateVariableParams object
// with the ability to set a context for a request.
func NewWaypointServiceCreateVariableParamsWithContext(ctx context.Context) *WaypointServiceCreateVariableParams {
	return &WaypointServiceCreateVariableParams{
		Context: ctx,
	}
}

// NewWaypointServiceCreateVariableParamsWithHTTPClient creates a new WaypointServiceCreateVariableParams object
// with the ability to set a custom HTTPClient for a request.
func NewWaypointServiceCreateVariableParamsWithHTTPClient(client *http.Client) *WaypointServiceCreateVariableParams {
	return &WaypointServiceCreateVariableParams{
		HTTPClient: client,
	}
}

/*
WaypointServiceCreateVariableParams contains all the parameters to send to the API endpoint

	for the waypoint service create variable operation.

	Typically these are written to a http.Request.
*/
type WaypointServiceCreateVariableParams struct {

	// Body.
	Body *models.HashicorpCloudWaypointV20241122WaypointServiceCreateVariableBody

	/* NamespaceLocationOrganizationID.

	   organization_id is the id of the organization.
	*/
	NamespaceLocationOrganizationID string

	/* NamespaceLocationProjectID.

	   project_id is the projects id.
	*/
	NamespaceLocationProjectID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the waypoint service create variable params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WaypointServiceCreateVariableParams) WithDefaults() *WaypointServiceCreateVariableParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the waypoint service create variable params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WaypointServiceCreateVariableParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the waypoint service create variable params
func (o *WaypointServiceCreateVariableParams) WithTimeout(timeout time.Duration) *WaypointServiceCreateVariableParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the waypoint service create variable params
func (o *WaypointServiceCreateVariableParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the waypoint service create variable params
func (o *WaypointServiceCreateVariableParams) WithContext(ctx context.Context) *WaypointServiceCreateVariableParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the waypoint service create variable params
func (o *WaypointServiceCreateVariableParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the waypoint service create variable params
func (o *WaypointServiceCreateVariableParams) WithHTTPClient(client *http.Client) *WaypointServiceCreateVariableParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the waypoint service create variable params
func (o *WaypointServiceCreateVariableParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the waypoint service create variable params
func (o *WaypointServiceCreateVariableParams) WithBody(body *models.HashicorpCloudWaypointV20241122WaypointServiceCreateVariableBody) *WaypointServiceCreateVariableParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the waypoint service create variable params
func (o *WaypointServiceCreateVariableParams) SetBody(body *models.HashicorpCloudWaypointV20241122WaypointServiceCreateVariableBody) {
	o.Body = body
}

// WithNamespaceLocationOrganizationID adds the namespaceLocationOrganizationID to the waypoint service create variable params
func (o *WaypointServiceCreateVariableParams) WithNamespaceLocationOrganizationID(namespaceLocationOrganizationID string) *WaypointServiceCreateVariableParams {
	o.SetNamespaceLocationOrganizationID(namespaceLocationOrganizationID)
	return o
}

// SetNamespaceLocationOrganizationID adds the namespaceLocationOrganizationId to the waypoint service create variable params
func (o *WaypointServiceCreateVariableParams) SetNamespaceLocationOrganizationID(namespaceLocationOrganizationID string) {
	o.NamespaceLocationOrganizationID = namespaceLocationOrganizationID
}

// WithNamespaceLocationProjectID adds the namespaceLocationProjectID to the waypoint service create variable params
func (o *WaypointServiceCreateVariableParams) WithNamespaceLocationProjectID(namespaceLocationProjectID string) *WaypointServiceCreateVariableParams {
	o.SetNamespaceLocationProjectID(namespaceLocationProjectID)
	return o
}

// SetNamespaceLocationProjectID adds the namespaceLocationProjectId to the waypoint service create variable params
func (o *WaypointServiceCreateVariableParams) SetNamespaceLocationProjectID(namespaceLocationProjectID string) {
	o.NamespaceLocationProjectID = namespaceLocationProjectID
}

// WriteToRequest writes these params to a swagger request
func (o *WaypointServiceCreateVariableParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param namespace.location.organization_id
	if err := r.SetPathParam("namespace.location.organization_id", o.NamespaceLocationOrganizationID); err != nil {
		return err
	}

	// path param namespace.location.project_id
	if err := r.SetPathParam("namespace.location.project_id", o.NamespaceLocationProjectID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
